<?php
require_once 'PHPOF2/DB.php';
require_once 'PHPOF2/Audit/GenericDb.php';

if (!isset($argv[1])) {
	die("Usage: $argv[0] [dsn]\n");
}

// The DSN to the main application database
// mysqli://user:pass@host/db
$dsn = $argv[1];

// Let's store the audit data in the same database as the main app data
$audit_driver = new PHPOF2_Audit_GenericDb($dsn);

$db_options = array('audit_driver' => $audit_driver);
$db = PHPOF2_DB::factory($dsn, $db_options);

class widgets extends PHPOF2_DBTable {
	protected $audit_logging = true;
}

$widgets = new widgets($db, 'widgets');

// $my_widget will be a PHPOF2_DBRow_Audited object, because audit_logging is on in class "widgets"
$my_widget = $widgets->createRowObject();

// This would come from some kind of authentication
$my_widget->setAuditOwner('bob');

// This would typically come from the UI, where Bob specified some information about the action he was performing
$my_widget->setAuditNote('Adding the new Flibble Widget, just arrived from Japan');

$my_widget->name = 'Flibble Widget';
$my_widget->price = 1;
$my_widget->insert();

$my_widget->name = 'Flibble Widget (UK version)';
$my_widget->setAuditNote('Distinguish the UK version of the Flibble widget from generic versions');
$my_widget->update();

