<?php
require_once 'PHPOF2/DB.php';
require_once 'PHPOF2/DBTable.php';
require_once 'PHPOF2/DBRow.php';

if (!isset($argv[1])) {
	die("Usage: $argv[0] [dsn]\n");
}
// The DSN to the main application database
$dsn = $argv[1];

foreach (array(PHPOF2_DB::LOB_STORAGE_DB, PHPOF2_DB::LOB_STORAGE_FS) as $storage_type) {
	$db_options = array(
		'lob_storage_fs_path' => dirname(__FILE__) . '/lobs/%t',
		'lob_storage' => $storage_type,
	);
	$db = PHPOF2_DB::factory($dsn, $db_options);

	$table = new PHPOF2_DBTable($db, 'lob_test');

	foreach(array('test1', 'test2') as $name) {
		$row = $table->createRowObject();
		$row->name = $name;
		$row->insert();
		$data_raw = file_get_contents(dirname(__FILE__) . "/$name.png");
		$row->storeLOBData($data_raw, 'data');
		$id = $row->id;
	
		$row = $table->createRowObject();
		$row->get($id);
		if ($row->data != PHPOF2_DB::LOB_PLACEHOLDER) {
			throw new Exception("Error when testing LOBs with storage type '$storage_type': no placeholder after retrieval of row ID $id");
		}
		if ($row->getLOBData('data') != $data_raw) {
			throw new Exception("Error when testing LOBs with storage type '$storage_type': data does not match after retrieval of row ID $id");
		}
	}
}

$table->migrateLOBStorage(PHPOF2_DB::LOB_STORAGE_FS);
$table->migrateLOBStorage(PHPOF2_DB::LOB_STORAGE_DB);

